diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsPumpkin.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsPumpkin.java
index fd7614437..e042cb912 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsPumpkin.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsPumpkin.java
@@ -46,8 +46,8 @@ public class BlockLogicCropsPumpkin
     }
 
     @Override
-    protected boolean mayPlaceOn(final int blockId) {
-        return blockId == Blocks.FARMLAND_DIRT.id();
+    protected boolean mayPlaceOn(final @NotNull Block<?> block) {
+        return block == Blocks.FARMLAND_DIRT;
     }
 
     @Override
@@ -60,7 +60,7 @@ public class BlockLogicCropsPumpkin
                 if (rand.nextInt((int) (100F / f)) == 0) {
                     meta++;
                     if (meta == 5) {
-                        world.setBlockIdDataNotify(tilePos, Blocks.PUMPKIN.id(), 0);
+                        world.setBlockTypeNotify(tilePos, Blocks.PUMPKIN);
                     } else {
                         world.setBlockDataNotify(tilePos, meta);
                     }
@@ -75,9 +75,9 @@ public class BlockLogicCropsPumpkin
         final @NotNull TilePos queryPos = new TilePos();
         for (localPos.x = tilePos.x() - 1; localPos.x <= tilePos.x() + 1; localPos.x++) {
             for (localPos.z = tilePos.z() - 1; localPos.z <= tilePos.z() + 1; localPos.z++) {
-                final int id = world.getBlockId(localPos.down(queryPos));
+                final @NotNull Block<?> block = world.getBlockType(localPos.down(queryPos));
                 float growthRateMod = 0.0F;
-                if (id == Blocks.FARMLAND_DIRT.id()) {
+                if (block == Blocks.FARMLAND_DIRT) {
                     growthRateMod = 1.0F;
                     if (world.getBlockData(localPos.down(queryPos)) > 0) {
                         growthRateMod = 3F;
@@ -120,7 +120,7 @@ public class BlockLogicCropsPumpkin
     public boolean onBonemealUsed(final @NotNull ItemStack itemStack, final @Nullable Player player, final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
         if (world.getBlockData(tilePos) < 5) {
             if (!world.isClientSide) {
-                world.setBlockIdNotify(tilePos, Blocks.PUMPKIN.id());
+                world.setBlockTypeNotify(tilePos, Blocks.PUMPKIN);
                 if (player == null || player.getGamemode().hasBlockConsumption()) {
                     itemStack.stackSize--;
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsWheat.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsWheat.java
index ffb87b722..9b2fdfbd6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsWheat.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsWheat.java
@@ -28,8 +28,8 @@ public class BlockLogicCropsWheat extends BlockLogicFlower implements IBonemeala
     }
 
     @Override
-    public boolean mayPlaceOn(final int blockId) {
-        return blockId == Blocks.FARMLAND_DIRT.id();
+    public boolean mayPlaceOn(final @NotNull Block<?> block) {
+        return block == Blocks.FARMLAND_DIRT;
     }
 
     @Override
@@ -49,24 +49,24 @@ public class BlockLogicCropsWheat extends BlockLogicFlower implements IBonemeala
     private float getGrowthRate(final @NotNull World world, final @NotNull TilePosc tilePos) {
         float growthRate = 1.0F;
         TilePos queryPos = new TilePos();
-        final int idNegZ = world.getBlockId(tilePos.north(queryPos));
-        final int idPosZ = world.getBlockId(tilePos.south(queryPos));
-        final int idNegX = world.getBlockId(tilePos.west(queryPos));
-        final int idPosX = world.getBlockId(tilePos.east(queryPos));
-        final int idNegXNegZ = world.getBlockId(tilePos.west(queryPos).north(queryPos));
-        final int idPosXNegZ = world.getBlockId(tilePos.east(queryPos).north(queryPos));
-        final int idPosXPosZ = world.getBlockId(tilePos.east(queryPos).south(queryPos));
-        final int idNegXPosZ = world.getBlockId(tilePos.west(queryPos).south(queryPos));
-        final boolean xNeighbor = idNegX == this.block.id() || idPosX == this.block.id();
-        final boolean zNeighbor = idNegZ == this.block.id() || idPosZ == this.block.id();
-        final boolean diagNeighbor = idNegXNegZ == this.block.id() || idPosXNegZ == this.block.id() || idPosXPosZ == this.block.id() || idNegXPosZ == this.block.id();
+        final @NotNull Block<?> bNegZ = world.getBlockType(tilePos.north(queryPos));
+        final @NotNull Block<?> bPosZ = world.getBlockType(tilePos.south(queryPos));
+        final @NotNull Block<?> bNegX = world.getBlockType(tilePos.west(queryPos));
+        final @NotNull Block<?> bPosX = world.getBlockType(tilePos.east(queryPos));
+        final @NotNull Block<?> bNegXNegZ = world.getBlockType(tilePos.west(queryPos).north(queryPos));
+        final @NotNull Block<?> bPosXNegZ = world.getBlockType(tilePos.east(queryPos).north(queryPos));
+        final @NotNull Block<?> bPosXPosZ = world.getBlockType(tilePos.east(queryPos).south(queryPos));
+        final @NotNull Block<?> bNegXPosZ = world.getBlockType(tilePos.west(queryPos).south(queryPos));
+        final boolean xNeighbor = bNegX == this.block || bPosX == this.block;
+        final boolean zNeighbor = bNegZ == this.block || bPosZ == this.block;
+        final boolean diagNeighbor = bNegXNegZ == this.block || bPosXNegZ == this.block || bPosXPosZ == this.block || bNegXPosZ == this.block;
 
         final @NotNull TilePos localPos = new TilePos(tilePos);
         for (localPos.x = tilePos.x() - 1; localPos.x <= tilePos.x() + 1; localPos.x++) {
             for (localPos.z = tilePos.z() - 1; localPos.z <= tilePos.z() + 1; localPos.z++) {
-                final int id = world.getBlockId(tilePos.down(queryPos));
+                final @NotNull Block<?> block = world.getBlockType(tilePos.down(queryPos));
                 float growthRateMod = 0.0F;
-                if (id == Blocks.FARMLAND_DIRT.id()) {
+                if (block == Blocks.FARMLAND_DIRT) {
                     growthRateMod = 1.0F;
                     if (world.getBlockData(tilePos.down(queryPos)) > 0) {
                         growthRateMod = 3F;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDeadBush.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDeadBush.java
index 9e0fa5e35..b49b765ca 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDeadBush.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDeadBush.java
@@ -18,8 +18,8 @@ public class BlockLogicDeadBush extends BlockLogicFlower {
     }
 
     @Override
-    public boolean mayPlaceOn(final int blockId) {
-        return blockId == Blocks.SAND.id() || blockId == Blocks.DIRT_SCORCHED.id() || BlockTags.GROWS_FLOWERS.appliesTo(Blocks.getBlock(blockId));
+    public boolean mayPlaceOn(final @NotNull Block<?> block) {
+        return block == Blocks.SAND || block == Blocks.DIRT_SCORCHED || block.hasTag(BlockTags.GROWS_FLOWERS);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java
index 0f35de874..324e4c224 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java
@@ -93,11 +93,11 @@ public class BlockLogicDispenser extends BlockLogicVeryRotatable {
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         final boolean hasNeighborSignal = world.hasNeighborSignal(tilePos);
         final int data = world.getBlockData(tilePos);
         if (hasNeighborSignal && (data & MASK_POWERED) == 0) {
-            world.scheduleBlockUpdate(tilePos, this.block.id(), this.tickDelay());
+            world.scheduleBlockUpdate(tilePos, this.block, this.tickDelay());
             world.setBlockData(tilePos, data | MASK_POWERED);
         } else if (!hasNeighborSignal) {
             world.setBlockData(tilePos, data & ~MASK_POWERED);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java
index 41db209ef..c7cb0675a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java
@@ -136,13 +136,13 @@ public class BlockLogicDoor
         TilePos queryPos = new TilePos();
         final int data = world.getBlockData(tilePos);
         if (this.isTop) {
-            final Block<?> b = world.getBlock(tilePos.down(queryPos));
+            final Block<?> b = world.getBlockType(tilePos.down(queryPos));
             if (b != null && b.getLogic() instanceof BlockLogicDoor blockLogicDoor) {
                 blockLogicDoor.onInteracted(world, tilePos.down(queryPos), player, side, xHit, yHit);
             }
             return true;
         }
-        final @Nullable Block<?> b = world.getBlock(tilePos.up(queryPos));
+        final @Nullable Block<?> b = world.getBlockType(tilePos.up(queryPos));
         if (b != null && b.getLogic() instanceof BlockLogicDoor) {
             world.setBlockDataNotify(tilePos.up(queryPos), data ^ MASK_OPENED);
         }
@@ -150,9 +150,9 @@ public class BlockLogicDoor
         world.setBlockDataNotify(tilePos, openedData);
         if (!this.isSupported(world, tilePos, openedData)) {
             this.dropWithCause(world, EnumDropCause.WORLD, tilePos, openedData, null, null);
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
             if (world.getBlockLogic(tilePos.up(queryPos), BlockLogicDoor.class) != null) {
-                world.setBlockIdNotify(tilePos.up(queryPos), 0);
+                world.setBlockTypeNotify(tilePos.up(queryPos), Blocks.AIR);
             }
         }
         world.markBlocksDirty(tilePos.down(queryPos), tilePos);
@@ -174,7 +174,7 @@ public class BlockLogicDoor
 
         TilePos queryPos = new TilePos();
         if (this.isTop) {
-            final @Nullable Block<?> b = world.getBlock(tilePos.down(queryPos));
+            final @Nullable Block<?> b = world.getBlockType(tilePos.down(queryPos));
             if (b != null && b.getLogic() instanceof BlockLogicDoor) {
                 ((BlockLogicDoor) b.getLogic()).onPoweredBlockChange(world, tilePos.down(queryPos), isPowered);
             }
@@ -184,7 +184,7 @@ public class BlockLogicDoor
         if (isOpen == isPowered) {
             return;
         }
-        final @Nullable Block<?> b = world.getBlock(tilePos.up(queryPos));
+        final @Nullable Block<?> b = world.getBlockType(tilePos.up(queryPos));
         if (b != null && b.getLogic() instanceof BlockLogicDoor) {
             world.setBlockDataNotify(tilePos.up(queryPos), data ^ MASK_OPENED);
         }
@@ -194,35 +194,34 @@ public class BlockLogicDoor
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         final int data = world.getBlockData(tilePos);
-        final @Nullable Block<?> neighbor = Blocks.getBlock(id);
 
         TilePos queryPos = new TilePos();
         if (this.isTop) {
-            final @Nullable Block<?> b = world.getBlock(tilePos.down(queryPos));
-            if (!(b != null && b.getLogic() instanceof BlockLogicDoor)) {
-                world.setBlockIdNotify(tilePos, 0);
+            final @NotNull Block<?> b = world.getBlockType(tilePos.down(queryPos));
+            if (!(b.getLogic() instanceof BlockLogicDoor)) {
+                world.setBlockTypeNotify(tilePos, Blocks.AIR);
             }
-            if (b != null && neighbor != null && neighbor.isSignalSource()) {
-                b.onNeighborChanged(world, tilePos.down(queryPos), id);
+            if (block.isSignalSource()) {
+                b.onNeighborChanged(world, tilePos.down(queryPos), b);
             }
         } else {
             boolean hasCommittedSuicide = false;
-            final @Nullable Block<?> otherBlock = world.getBlock(tilePos.up(queryPos));
-            if (!(otherBlock != null && otherBlock.getLogic() instanceof BlockLogicDoor)) {
-                world.setBlockIdNotify(tilePos, 0);
+            final @NotNull Block<?> otherBlock = world.getBlockType(tilePos.up(queryPos));
+            if (!(otherBlock.getLogic() instanceof BlockLogicDoor)) {
+                world.setBlockTypeNotify(tilePos, Blocks.AIR);
                 hasCommittedSuicide = true;
             }
             if (!this.isSupported(world, tilePos, data)) {
                 this.dropWithCause(world, EnumDropCause.WORLD, tilePos, data, null, null);
-                world.setBlockIdNotify(tilePos, 0);
+                world.setBlockTypeNotify(tilePos, Blocks.AIR);
                 hasCommittedSuicide = true;
-                if (otherBlock != null && otherBlock.getLogic() instanceof BlockLogicDoor) {
-                    world.setBlockIdNotify(tilePos.up(queryPos), 0);
+                if (otherBlock.getLogic() instanceof BlockLogicDoor) {
+                    world.setBlockTypeNotify(tilePos.up(queryPos), Blocks.AIR);
                 }
             }
-            if (!hasCommittedSuicide && neighbor != null && neighbor.isSignalSource()) {
+            if (!hasCommittedSuicide && block.isSignalSource()) {
                 final boolean hasSignal = world.hasNeighborSignal(tilePos) || world.hasNeighborSignal(tilePos.up(queryPos));
                 this.onPoweredBlockChange(world, tilePos, hasSignal);
             }
@@ -234,11 +233,11 @@ public class BlockLogicDoor
         TilePos queryPos = new TilePos();
         if (this.isTop) {
             if (world.getBlockLogic(tilePos.down(queryPos), BlockLogicDoor.class) != null) {
-                world.setBlockIdNotify(tilePos.down(queryPos), 0);
+                world.setBlockTypeNotify(tilePos.down(queryPos), Blocks.AIR);
             }
         } else {
             if (world.getBlockLogic(tilePos.up(queryPos), BlockLogicDoor.class) != null) {
-                world.setBlockIdNotify(tilePos.up(queryPos), 0);
+                world.setBlockTypeNotify(tilePos.up(queryPos), Blocks.AIR);
             }
         }
     }
@@ -412,14 +411,14 @@ public class BlockLogicDoor
         TilePos queryPos = new TilePos();
         final int data = world.getBlockData(tilePos);
         if (this.isTop) {
-            world.setBlockIdDataRaw(tilePos, Blocks.DOOR_PLANKS_PAINTED_TOP.id(), data);
+            world.setBlockTypeDataRaw(tilePos, Blocks.DOOR_PLANKS_PAINTED_TOP, data);
             Blocks.DOOR_PLANKS_PAINTED_TOP.getLogic().setColor(world, tilePos, color);
-            world.setBlockIdDataRaw(tilePos.down(queryPos), Blocks.DOOR_PLANKS_PAINTED_BOTTOM.id(), data);
+            world.setBlockTypeDataRaw(tilePos.down(queryPos), Blocks.DOOR_PLANKS_PAINTED_BOTTOM, data);
             Blocks.DOOR_PLANKS_PAINTED_BOTTOM.getLogic().setColor(world, tilePos.down(queryPos), color);
         } else {
-            world.setBlockIdDataRaw(tilePos, Blocks.DOOR_PLANKS_PAINTED_BOTTOM.id(), data);
+            world.setBlockTypeDataRaw(tilePos, Blocks.DOOR_PLANKS_PAINTED_BOTTOM, data);
             Blocks.DOOR_PLANKS_PAINTED_BOTTOM.getLogic().setColor(world, tilePos, color);
-            world.setBlockIdDataRaw(tilePos.up(queryPos), Blocks.DOOR_PLANKS_PAINTED_TOP.id(), data);
+            world.setBlockTypeDataRaw(tilePos.up(queryPos), Blocks.DOOR_PLANKS_PAINTED_TOP, data);
             Blocks.DOOR_PLANKS_PAINTED_TOP.getLogic().setColor(world, tilePos.up(queryPos), color);
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoorPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoorPainted.java
index 46654d5ca..84b830ae8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoorPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoorPainted.java
@@ -42,11 +42,11 @@ public class BlockLogicDoorPainted
     @Override
     public void removeDye(final @NotNull World world, final @NotNull TilePosc tilePos) {
         final int data = world.getBlockData(tilePos);
-        world.setBlockIdDataNotify(tilePos, this.isTop ? Blocks.DOOR_PLANKS_OAK_TOP.id() : Blocks.DOOR_PLANKS_OAK_BOTTOM.id(), data & 0xF);
+        world.setBlockTypeDataNotify(tilePos, this.isTop ? Blocks.DOOR_PLANKS_OAK_TOP : Blocks.DOOR_PLANKS_OAK_BOTTOM, data & 0xF);
         if (this.isTop) {
-            world.setBlockIdDataNotify(tilePos.down(new TilePos()), Blocks.DOOR_PLANKS_OAK_BOTTOM.id(), data & 0xF);
+            world.setBlockTypeDataNotify(tilePos.down(new TilePos()), Blocks.DOOR_PLANKS_OAK_BOTTOM, data & 0xF);
         } else {
-            world.setBlockIdDataNotify(tilePos.up(new TilePos()), Blocks.DOOR_PLANKS_OAK_TOP.id(), data & 0xF);
+            world.setBlockTypeDataNotify(tilePos.up(new TilePos()), Blocks.DOOR_PLANKS_OAK_TOP, data & 0xF);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicEdible.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicEdible.java
index 54e75a7ac..3da2eec24 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicEdible.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicEdible.java
@@ -58,7 +58,7 @@ public abstract class BlockLogicEdible
             player.heal(this.getHealAmount(world, tilePos));
             final int data = world.getBlockData(tilePos) + 1;
             if (data >= this.maxBites) {
-                world.setBlockIdNotify(tilePos, 0);
+                world.setBlockTypeNotify(tilePos, Blocks.AIR);
             } else {
                 world.setBlockDataNotify(tilePos, data);
                 world.markBlockDirty(tilePos);
@@ -93,9 +93,9 @@ public abstract class BlockLogicEdible
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         if (!this.canStay(world, tilePos)) {
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
index 522ed5823..2f534c8e2 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
@@ -105,7 +105,7 @@ public class BlockLogicFarmland
         final @NotNull TilePos localPos = new TilePos(tilePos);
         for (localPos.x = tilePos.x() - radius; localPos.x <= tilePos.x() + radius; localPos.x++) {
             for (localPos.z = tilePos.z() - radius; localPos.z <= tilePos.z() + radius; localPos.z++) {
-                if (world.getBlockId(localPos.set(localPos.x, tilePos.y() + 1, localPos.z)) == Blocks.CROPS_WHEAT.id()) {
+                if (world.getBlockType(localPos.set(localPos.x, tilePos.y() + 1, localPos.z)) == Blocks.CROPS_WHEAT) {
                     return true;
                 }
             }
@@ -130,7 +130,7 @@ public class BlockLogicFarmland
         for (localPos.x = tilePos.x() - range; localPos.x <= tilePos.x() + range; localPos.x++) {
             for (localPos.y = tilePos.y() - range; localPos.y <= tilePos.y() + range; localPos.y++) {
                 for (localPos.z = tilePos.z() - range; localPos.z <= tilePos.z() + range; localPos.z++) {
-                    if (Blocks.hasTag(world.getBlockId(localPos), BlockTags.IS_WATER)) {
+                    if (world.getBlockType(localPos).hasTag(BlockTags.IS_WATER)) {
                         return true;
                     }
                 }
@@ -149,9 +149,9 @@ public class BlockLogicFarmland
                     return;
                 }
                 if (isWet(world.getBlockData(tilePos))) {
-                    world.setBlockIdNotify(tilePos, Blocks.MUD.id());
+                    world.setBlockTypeNotify(tilePos, Blocks.MUD);
                 } else {
-                    world.setBlockIdNotify(tilePos, Blocks.DIRT.id());
+                    world.setBlockTypeNotify(tilePos, Blocks.DIRT);
                 }
             }
         }
@@ -159,20 +159,20 @@ public class BlockLogicFarmland
 
     @Override
     public void onPlacedByWorld(final @NotNull World world, final @NotNull TilePosc tilePos) {
-        world.scheduleBlockUpdate(tilePos, this.block.id(), this.tickDelay() - world.rand.nextInt(10) + world.rand.nextInt(10));
+        world.scheduleBlockUpdate(tilePos, this.block, this.tickDelay() - world.rand.nextInt(10) + world.rand.nextInt(10));
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         final @NotNull Material material = world.getBlockMaterial(tilePos.up(new TilePos()));
         if (material.isSolid() && material != Materials.VEGETABLE) {
             if (isWet(world.getBlockData(tilePos))) {
-                world.setBlockIdNotify(tilePos, Blocks.MUD.id());
+                world.setBlockTypeNotify(tilePos, Blocks.MUD);
             } else {
-                world.setBlockIdNotify(tilePos, Blocks.DIRT.id());
+                world.setBlockTypeNotify(tilePos, Blocks.DIRT);
             }
         } else {
-            world.scheduleBlockUpdate(tilePos, this.block.id(), this.tickDelay() - world.rand.nextInt(10) + world.rand.nextInt(10));
+            world.scheduleBlockUpdate(tilePos, this.block, this.tickDelay() - world.rand.nextInt(10) + world.rand.nextInt(10));
         }
     }
 
@@ -188,8 +188,8 @@ public class BlockLogicFarmland
                 for (localPos.y = tilePos.y() - 1; localPos.y <= tilePos.y() + 1; localPos.y++) {
                     for (localPos.z = tilePos.z() - 1; localPos.z <= tilePos.z() + 1; localPos.z++) {
                         //...And the block is next to another wet mud block, it can become wet
-                        final int bID = world.getBlockId(localPos);
-                        if (bID == Blocks.MUD.id() || (bID == Blocks.FARMLAND_DIRT.id() && BlockLogicFarmland.isWet(world.getBlockData(localPos)))) {
+                        final @NotNull Block<?> block = world.getBlockType(localPos);
+                        if (block == Blocks.MUD || (block == Blocks.FARMLAND_DIRT && BlockLogicFarmland.isWet(world.getBlockData(localPos)))) {
                             return true;
                         }
                     }
@@ -209,7 +209,7 @@ public class BlockLogicFarmland
     @Override
     public void updateTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand, final boolean isRandomTick) {
         if (rand.nextInt(2) != 0) {
-            world.scheduleBlockUpdate(tilePos, this.block.id(), this.tickDelay() - rand.nextInt(10) + rand.nextInt(10));
+            world.scheduleBlockUpdate(tilePos, this.block, this.tickDelay() - rand.nextInt(10) + rand.nextInt(10));
             return;
         }
         final int data = world.getBlockData(tilePos);
@@ -217,14 +217,14 @@ public class BlockLogicFarmland
         if (this.isWaterNearby(world, tilePos, 4) || world.isBlockBeingRainedOn(tilePos.up(new TilePos()))) {
             if (hydration < 15 && this.canBecomeWet(world, tilePos)) {
                 world.setBlockDataNotify(tilePos, setWet(data, hydration + 1));
-                world.scheduleBlockUpdate(tilePos, this.block.id(), this.tickDelay() - rand.nextInt(10) + rand.nextInt(10));
+                world.scheduleBlockUpdate(tilePos, this.block, this.tickDelay() - rand.nextInt(10) + rand.nextInt(10));
             }
         } else {
             if (hydration > 0) {
                 world.setBlockDataNotify(tilePos, setWet(data, hydration - 1));
-                world.scheduleBlockUpdate(tilePos, this.block.id(), this.tickDelay() - rand.nextInt(10) + rand.nextInt(10));
+                world.scheduleBlockUpdate(tilePos, this.block, this.tickDelay() - rand.nextInt(10) + rand.nextInt(10));
             } else if (!this.isCropsNearby(world, tilePos)) {
-                world.setBlockIdNotify(tilePos, Blocks.DIRT.id());
+                world.setBlockTypeNotify(tilePos, Blocks.DIRT);
             }
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java
index 7fba10c2d..9df34cb76 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java
@@ -89,8 +89,8 @@ public class BlockLogicFence
 
     public boolean canConnectTo(final @NotNull WorldSource source, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         TilePos queryPos = new TilePos();
-        final Block<?> b = source.getBlock(tilePos.add(side.getDirection(), queryPos));
-        return Blocks.hasTag(b, BlockTags.FENCES_CONNECT) || (b != null && b.getAttachedSide(source, tilePos.add(side.getDirection(), queryPos)) == side.getOpposite());
+        final @NotNull Block<?> b = source.getBlockType(tilePos.add(side.getDirection(), queryPos));
+        return Blocks.hasTag(b, BlockTags.FENCES_CONNECT) || b.getAttachedSide(source, tilePos.add(side.getDirection(), queryPos)) == side.getOpposite();
     }
 
     @Deprecated
@@ -100,7 +100,7 @@ public class BlockLogicFence
 
     @Override
     public void setColor(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull DyeColor color) {
-        world.setBlockId(tilePos, Blocks.FENCE_PLANKS_OAK_PAINTED.id());
+        world.setBlockType(tilePos, Blocks.FENCE_PLANKS_OAK_PAINTED);
         Blocks.FENCE_PLANKS_OAK_PAINTED.getLogic().setColor(world, tilePos, color);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceChainlink.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceChainlink.java
index 8d43bf7ea..072597a2c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceChainlink.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceChainlink.java
@@ -18,7 +18,7 @@ public class BlockLogicFenceChainlink extends BlockLogicFenceThin {
     @Override
     public boolean canConnectTo(final @NotNull WorldSource source, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         TilePos queryPos = new TilePos();
-        final @Nullable Block<?> b = source.getBlock(tilePos.add(side.getDirection(), queryPos));
+        final @Nullable Block<?> b = source.getBlockType(tilePos.add(side.getDirection(), queryPos));
         return Blocks.hasTag(b, BlockTags.CHAINLINK_FENCES_CONNECT) || (b != null && b.getAttachedSide(source, tilePos.add(side.getDirection(), queryPos)) == side.getOpposite());
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java
index 4072c74cd..c74ebaa0f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java
@@ -119,7 +119,7 @@ public class BlockLogicFenceGate
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         final int data = world.getBlockData(tilePos);
         final boolean wasPowered = isPowered(data);
         final boolean hasPower = world.hasNeighborSignal(tilePos) || world.hasDirectSignal(tilePos);
@@ -151,7 +151,7 @@ public class BlockLogicFenceGate
 
     @Override
     public void setColor(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull DyeColor color) {
-        world.setBlockIdDataNotify(tilePos, Blocks.FENCE_GATE_PLANKS_OAK_PAINTED.id(), world.getBlockData(tilePos));
+        world.setBlockTypeDataNotify(tilePos, Blocks.FENCE_GATE_PLANKS_OAK_PAINTED, world.getBlockData(tilePos));
         Blocks.FENCE_GATE_PLANKS_OAK_PAINTED.getLogic().setColor(world, tilePos, color);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGatePainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGatePainted.java
index f280a126d..9e52ed8c7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGatePainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGatePainted.java
@@ -46,7 +46,7 @@ public class BlockLogicFenceGatePainted extends BlockLogicFenceGate implements I
     @Override
     public void removeDye(final @NotNull World world, final @NotNull TilePosc tilePos) {
         final int meta = world.getBlockData(tilePos);
-        world.setBlockIdDataNotify(tilePos, Blocks.FENCE_GATE_PLANKS_OAK.id(), meta & ~MASK_COLOR);
+        world.setBlockTypeDataNotify(tilePos, Blocks.FENCE_GATE_PLANKS_OAK, meta & ~MASK_COLOR);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFencePainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFencePainted.java
index 9b3700013..d8a7f1ae4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFencePainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFencePainted.java
@@ -43,7 +43,7 @@ public class BlockLogicFencePainted extends BlockLogicFence implements IPainted
 
     @Override
     public void removeDye(final @NotNull World world, final @NotNull TilePosc tilePos) {
-        world.setBlockIdNotify(tilePos, Blocks.FENCE_PLANKS_OAK.id());
+        world.setBlockTypeNotify(tilePos, Blocks.FENCE_PLANKS_OAK);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceSteel.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceSteel.java
index 30c787238..1493510e1 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceSteel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceSteel.java
@@ -18,7 +18,7 @@ public class BlockLogicFenceSteel
     @Override
     public boolean canConnectTo(final @NotNull WorldSource source, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         TilePos queryPos = new TilePos();
-        final @Nullable Block<?> b = source.getBlock(tilePos.add(side.getDirection(), queryPos));
+        final @Nullable Block<?> b = source.getBlockType(tilePos.add(side.getDirection(), queryPos));
         return Blocks.hasTag(b, BlockTags.CHAINLINK_FENCES_CONNECT) || (b != null && b.getAttachedSide(source, tilePos.add(side.getDirection(), queryPos)) == side.getOpposite());
     }
 }
